/**********************************************************/
/*    filename:bbi_pars.cpp \                      */
/**********************************************************/
#include "bbi.h"
#include "bbi_prot.h"

#define NO_FIX_ADRS 0                                 /* ܂Ԓñ}[N */
Token token;                                          /* ݏ̃g[N */
SymTbl tmpTb;                                               /* ꎞi[L\ */
int blkNest;                                                /* ubN̐[ */
int localAdrs;                                        /* ǏϐAhXǗ */
int mainTblNbr;                             /* main֐΂̋L\ʒu */
int loopNest;                                                 /* [vlXg */
bool fncDecl_F;                                       /* ֐`Ȃ^ */
bool explicit_F;                                        /* ^Ȃϐ錾 */
char codebuf[LIN_SIZ+1], *codebuf_p;                  /* R[hƗp */
extern vector<char*> intercode;                     /* ϊςݓR[hi[ */

void init() /* lݒ */
{
  initChTyp();                                                    /* \ */
  mainTblNbr = -1;
  blkNest = loopNest = 0;
  fncDecl_F = explicit_F = false;
  codebuf_p = codebuf;
}

void convert_to_internalCode(char *fname) /* R[hϊ */
{
  init();                                               /* \ȂǏ */

  // ֐`̂ݐɓo^
  fileOpen(fname);
  while (token=nextLine_tkn(), token.kind != EofProg) {
    if (token.kind == Func) {
      token = nextTkn(); set_name(); enter(tmpTb, fncId);
    }
  }

  // R[hւ̕ϊ
  push_intercode();                                /* 0sڂ͕svȂ̂Ŗ߂ */
  fileOpen(fname);
  token = nextLine_tkn();
  while (token.kind != EofProg) {
    convert();                                            /* R[hɕϊ */
  }

  // main֐΂̌ĂяoR[hݒ
  set_startPc(1);                                        /* 1sڂsJn */
  if (mainTblNbr != -1) {
    set_startPc(intercode.size());                        /* mainsJn */
    setCode(Fcall, mainTblNbr); setCode('('); setCode(')');
    push_intercode();
  }
}

// 擪ɏoR[hBc蕔convert_rest()ŏ
void convert()
{
  switch (token.kind) {
  case Option: optionSet(); break;                          /* IvVݒ */
  case Var:    varDecl();   break;                                /* ϐ錾 */
  case Func:   fncDecl();   break;                                /* ֐` */
  case While: case For:
       ++loopNest;
       convert_block_set(); setCode_End();
       --loopNest;
       break;
  case If:
       convert_block_set();                                // if
       while (token.kind == Elif) { convert_block_set(); } // elif
       if (token.kind == Else)    { convert_block_set(); } // else
       setCode_End();                                      // end
       break;
  case Break:
       if (loopNest <= 0) err_exit("sbreakłB");
       setCode(token.kind); token = nextTkn(); convert_rest();
       break;
  case Return:
       if (!fncDecl_F) err_exit("sreturnłB");
       setCode(token.kind); token = nextTkn(); convert_rest();
       break;
  case Exit:
       setCode(token.kind); token = nextTkn(); convert_rest();
       break;
  case Print: case Println:
       setCode(token.kind); token = nextTkn(); convert_rest();
       break;
  case End:
       err_exit("s end łB");       /* end PƂŎg邱Ƃ͂Ȃ */
       break;
  default: convert_rest(); break;
  }
}

void convert_block_set() /* ubNǗ */
{
  int patch_line;
  patch_line = setCode(token.kind, NO_FIX_ADRS); token = nextTkn();
  convert_rest();
  convert_block();                                            /* ubN */
  backPatch(patch_line, get_lineNo());        /* NO_FIX_ADRSC(endsԍ) */
}

void convert_block() /* ubN̏ */
{
  TknKind k;
  ++blkNest;                                      /* ubNI[܂ŕ */
  while(k=token.kind, k!=Elif && k!=Else && k!=End && k!=EofProg) {
    convert();
  }
  --blkNest;
}

void convert_rest() /* ̎c̏ */
{
  int tblNbr;

  for (;;) {
    if (token.kind == EofLine) break;
    switch (token.kind) {      //̃L[[hrɌ邱Ƃ͂Ȃ */
    case If: case Elif: case Else: case For: case While: case Break:
    case Func:  case Return:  case Exit:  case Print:  case Println:
    case Option: case Var: case End:
         err_exit("sȋLqł: ", token.text);
         break;
    case Ident:                                              /* ֐ďo,ϐ */
         set_name();
         if ((tblNbr=searchName(tmpTb.name, 'F')) != -1) {    /* ֐o^ */
           if (tmpTb.name == "main") err_exit("main֐̌ďo͂ł܂B");
           setCode(Fcall, tblNbr); continue;
         }
         if ((tblNbr=searchName(tmpTb.name, 'V')) == -1) {    /* ϐo^Ȃ */
           if (explicit_F) err_exit("ϐ錾Kvł: ", tmpTb.name);
           tblNbr = enter(tmpTb, varId);                      /* ϐo^ */
         }
         if (is_localName(tmpTb.name, varId)) setCode(Lvar, tblNbr);
         else                                 setCode(Gvar, tblNbr);
         continue;
     case IntNum: case DblNum:                         /* double^Ŋi[ */
         setCode(token.kind, set_LITERAL(token.dblVal));
         break;
     case String:
         setCode(token.kind, set_LITERAL(token.text));
         break;
    default:                                                   /* + - <= Ȃ */
         setCode(token.kind);
         break;
    }
    token = nextTkn();
  }
  push_intercode();
  token = nextLine_tkn();
}

void optionSet() /* IvVݒ */
{
  setCode(Option);            /* ̍s͔sȂ̂ŃR[hϊ Option  */
  setCode_rest();                                       /* c͌̂܂܊i[ */
  token = nextTkn();                                  /* ϐ錾 */
  if (token.kind==String && token.text=="var") explicit_F = true;
  else err_exit("optionw肪słB");
  token = nextTkn();
  setCode_EofLine();
}

void varDecl() /* vargϐ錾 */
{
  setCode(Var);                  /* ̍s͔sȂ̂ŃR[hϊ Var  */
  setCode_rest();                                       /* c͌̂܂܊i[ */
  for (;;) {
    token = nextTkn();
    var_namechk(token);                                           /* O */
    set_name(); set_aryLen();                             /* zȂ璷ݒ */
    enter(tmpTb, varId);                          /* ϐo^(AhXݒ) */
    if (token.kind != ',') break;                                 /* 錾I */
  }
  setCode_EofLine();
}

void var_namechk(const Token& tk) /* OmF */
{
  if (tk.kind != Ident) err_exit(err_msg(tk.text, "ʎq"));
  if (is_localScope() && tk.text[0] == '$')
    err_exit("֐var錾ł $ tOwł܂: ", tk.text);
  if (searchName(tk.text, 'V') != -1)
    err_exit("ʎqdĂ܂: ", tk.text);
}

void set_name() /* Oݒ */
{
  if (token.kind != Ident) err_exit("ʎqKvł: ", token.text);
  tmpTb.clear(); tmpTb.name = token.text;                         /* Oݒ */
  token = nextTkn();
}

void set_aryLen() /* zTCYݒ */
{
  tmpTb.aryLen = 0;
  if (token.kind != '[') return;                                /* złȂ */

  token = nextTkn();
  if (token.kind != IntNum)
    err_exit("z񒷂͐̐萔Ŏw肵Ă: ", token.text);
  tmpTb.aryLen = (int)token.dblVal + 1;   /* var a[5]͓Y0`5LȂ̂+1 */
  token = chk_nextTkn(nextTkn(), ']');
  if (token.kind == '[') err_exit("z͐錾ł܂B");
}

void fncDecl() /* ֐` */
{
  extern vector<SymTbl> Gtable;                                 /* L\ */
  int tblNbr, patch_line, fncTblNbr;

  if(blkNest > 0) err_exit("֐`̈ʒusłB");
  fncDecl_F = true;                                     /* ֐JntO */
  localAdrs = 0;                              /* Ǐ̈抄tJE^ */
  set_startLtable();                                    /* ǏL\Jnʒu */
  patch_line = setCode(Func, NO_FIX_ADRS);          /* Ƃendsԍ*/
  token = nextTkn();

  fncTblNbr = searchName(token.text, 'F');      /* ֐͍ŏɓo^Ă */
  Gtable[fncTblNbr].dtTyp = DBL_T;                      /* ֐^doubleŒ */

  // 
  token = nextTkn();
  token = chk_nextTkn(token, '(');                               /* '('̂͂ */
  setCode('(');
  if (token.kind != ')') {                                        /*  */
    for (;; token=nextTkn()) {
      set_name();
      tblNbr = enter(tmpTb, paraId);                              /* o^ */
      setCode(Lvar, tblNbr);                          /* LvarƂď */
      ++Gtable[fncTblNbr].args;                               /* +1 */
      if (token.kind != ',') break;                               /* 錾I */
      setCode(',');
    }
  }
  token = chk_nextTkn(token, ')');                               /* ')'̂͂ */
  setCode(')'); setCode_EofLine();
  convert_block();                                            /* ֐{̏ */

  backPatch(patch_line, get_lineNo());                   /* NO_FIX_ADRSC */
  setCode_End();
  Gtable[fncTblNbr].frame = localAdrs;                      /* t[TCY */

  if (Gtable[fncTblNbr].name == "main") {                     /* main֐ */
    mainTblNbr = fncTblNbr;
    if (Gtable[mainTblNbr].args != 0)
      err_exit("main֐ł͉wł܂B");
  }
  fncDecl_F = false;                                          /* ֐I */
}

void backPatch(int line, int n) /* linesnݒ */
{
  *SHORT_P(intercode[line] + 1) = (short)n;
}

void setCode(int cd) /* R[hi[ */
{
  *codebuf_p++ = (char)cd;
}

int setCode(int cd, int nbr) /* R[hshortli[ */
{
  *codebuf_p++ = (char)cd;
  *SHORT_P(codebuf_p) = (short)nbr; codebuf_p += SHORT_SIZ;
  return get_lineNo();                           /* backPatchpɊi[sԂ */
}

void setCode_rest() /* c̃eLXĝ܂܊i[ */
{
  extern char *token_p;
  strcpy(codebuf_p, token_p);
  codebuf_p += strlen(token_p) + 1;
}

void setCode_End() /* end̊i[ */
{
  if (token.kind != End) err_exit(err_msg(token.text, "end"));
  setCode(End); token = nextTkn(); setCode_EofLine();
}

void setCode_EofLine() /* ŏIi[ */
{
  if (token.kind != EofLine) err_exit("sȋLqł: ", token.text);
  push_intercode();
  token = nextLine_tkn();                                     /* ̍sɐi */
}

void push_intercode() /* ϊR[hi[ */
{
  int len;
  char *p;

  *codebuf_p++ = '\0';
  if ((len = codebuf_p-codebuf) >= LIN_SIZ)
    err_exit("ϊ̓R[h܂BZĂB");

  try {
    p = new char[len];                                          /* m */
    memcpy(p, codebuf, len);
    intercode.push_back(p);
  }
  catch (bad_alloc) { err_exit("mۂł܂"); }
  codebuf_p = codebuf;                /* ̏̂߂Ɋi[擪Ɉʒut */
}

bool is_localScope() /* ֐Ȃ^ */
{
  return fncDecl_F;
}

