/*-------------------------------------------*/
/*    t|[hL@̕] polish_p.cpp    */
/*-------------------------------------------*/
#include <iostream>
#include <cstdlib>      // for exit()
#include <cctype>       // for is...()
using namespace std;

void polish(char *s);
int execute();
int getvalue(int ch);
int order(int ch);
void push(int n);
int pop();

#define STK_SIZ 20
int stack[STK_SIZ+1];                                    /* X^bN */
int stkct;                                       /* X^bN|C^ */
char plsh_out[80];                             /* t|[ho͐ */

int main()
{
    char siki[80];
    int ans;

    cout << ": "; cin.getline(siki, 80);          /* 1sǂݍ */
    polish(siki);
    if (plsh_out[0] == '\0') exit(1);              /* LȎȂ */
    ans = execute();
    cout << "ϊ: " << plsh_out << endl;
    cout << ": " << ans << endl;

    return 0;
}

void polish(char *s)
{
    int wk;
    char *out = plsh_out;

    stkct = 0;
    for (;;) {
        while (isspace(*s)) { ++s; }           /* 󔒃XLbv       */
        if (*s == '\0') {                      /* ɂȂ       */
            while (stkct > 0) {                /* X^bNco */
                if ((*out++ = pop()) == '(') {
                    puts("'('s\n"); exit(1);
                }
            }
            break;
        }
        if (islower(*s) || isdigit(*s)) {       /* ϐȂo*/
            *out++ = *s++; continue;
        }
        switch (*s) {
        case '(':                              /* ( Ȃς         */
            push(*s);
            break;
        case ')':                              /* ) Ȃ             */
            while ((wk = pop()) != '(') {      /* ( ɉ܂ŏo   */
                *out++ = wk;
                if (stkct == 0) { puts("'('s\n"); exit(1); }
            }
            break;
        default:                               /* Zq             */
            if (order(*s) == -1) {             /* psK       */
                cout << "sȕ: " << *s << endl; exit(1);
            }            /* ȏ㋭vfX^bNgbvɂ */
            while (stkct>0 && (order(stack[stkct]) >= order(*s))) {
                *out++ = pop();                /* X^bNeo */
            }
            push(*s);                          /* vfς       */
        }
        s++;
    }
    *out = '\0';
}

int execute()                                            /* ̌vZ */
{
    int d1, d2;
    char *s;

    stkct = 0;
    for (s=plsh_out; *s; s++) {
        if (islower(*s))                       /* ϐȂ           */
            push(getvalue(*s));                /* lX^bNɐς */
        else if (isdigit(*s))                  /* Ȃ           */
            push(*s - '0');                    /* lX^bNɐς */
        else {                                 /* ZqȂ         */
            d2 = pop(); d1 = pop();            /* 2̒lo  */
            switch (*s) {
            case '+': push(d1+d2); break;      /* vZʂς     */
            case '-': push(d1-d2); break;
            case '*': push(d1*d2); break;
            case '/': if (d2 == 0) { puts("[Z"); exit(1); }
                      push(d1/d2); break;
            }
        }
    }
    if (stkct != 1) { cout << "error\n"; exit(1); }
    return pop();                                      /* ʂԂ */
}

int getvalue(int ch)                                  /* 1`26Ԃ */
{
    if (islower(ch)) return ch-'a' + 1;
    return 0;
}

int order(int ch)                                        /* D揇 */
{
    switch (ch) {
    case '*': case '/': return 3;
    case '+': case '-': return 2;
    case '(':           return 1;
    }
    return -1;
}

void push(int n)                                     /* X^bNύ */
{
    if (stkct+1 > STK_SIZ) { puts("stack overflow"); exit(1); }
    stack[++stkct] = n;
}

int pop()                                            /* X^bNo */
{
    if (stkct < 1) { puts("stack underflow"); exit(1); }
    return stack[stkct--];
}
